// DO NOT EDIT - AUTOGENERATED (by protogen.go)

package neo

import (
	"encoding/binary"
)

func (p *Address) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Host = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	p.Port = binary.BigEndian.Uint16(data[0:])
	return int(nread) + 2, nil
}

func (p *NodeInfo) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.NodeType = NodeType(int32(binary.BigEndian.Uint32(data[0:])))
	{
		l := binary.BigEndian.Uint32(data[4:])
		data = data[8:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Address.Host = string(data[:l])
		data = data[l:]
		nread += 8 + l
	}
	p.Address.Port = binary.BigEndian.Uint16(data[0:])
	p.UUID = UUID(int32(binary.BigEndian.Uint32(data[2:])))
	p.NodeState = NodeState(int32(binary.BigEndian.Uint32(data[6:])))
	p.IdTimestamp = float64_NEODecode(data[10:])
	return int(nread) + 18, nil
}

func (p *CellInfo) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
	p.CellState = CellState(int32(binary.BigEndian.Uint32(data[4:])))
	return int(nread) + 8, nil
}

func (p *RowInfo) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Offset = binary.BigEndian.Uint32(data[0:])
	{
		l := binary.BigEndian.Uint32(data[4:])
		data = data[8:]
		nread += 8
		p.CellList = make([]CellInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.CellList[i]
			(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
			(*a).CellState = CellState(int32(binary.BigEndian.Uint32(data[4:])))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *Notify) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Message = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	return int(nread) + 0, nil
}

func (p *Error) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Code = binary.BigEndian.Uint32(data[0:])
	{
		l := binary.BigEndian.Uint32(data[4:])
		data = data[8:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Message = string(data[:l])
		data = data[l:]
		nread += 8 + l
	}
	return int(nread) + 0, nil
}

func (p *Ping) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *CloseClient) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *RequestIdentification) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.ProtocolVersion = binary.BigEndian.Uint32(data[0:])
	p.NodeType = NodeType(int32(binary.BigEndian.Uint32(data[4:])))
	p.UUID = UUID(int32(binary.BigEndian.Uint32(data[8:])))
	{
		l := binary.BigEndian.Uint32(data[12:])
		data = data[16:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Address.Host = string(data[:l])
		data = data[l:]
		nread += 16 + l
	}
	p.Address.Port = binary.BigEndian.Uint16(data[0:])
	{
		l := binary.BigEndian.Uint32(data[2:])
		data = data[6:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Name = string(data[:l])
		data = data[l:]
		nread += 6 + l
	}
	p.IdTimestamp = float64_NEODecode(data[0:])
	return int(nread) + 8, nil
}

func (p *AcceptIdentification) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.NodeType = NodeType(int32(binary.BigEndian.Uint32(data[0:])))
	p.MyUUID = UUID(int32(binary.BigEndian.Uint32(data[4:])))
	p.NumPartitions = binary.BigEndian.Uint32(data[8:])
	p.NumReplicas = binary.BigEndian.Uint32(data[12:])
	p.YourUUID = UUID(int32(binary.BigEndian.Uint32(data[16:])))
	{
		l := binary.BigEndian.Uint32(data[20:])
		data = data[24:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Primary.Host = string(data[:l])
		data = data[l:]
		nread += 24 + l
	}
	p.Primary.Port = binary.BigEndian.Uint16(data[0:])
	{
		l := binary.BigEndian.Uint32(data[2:])
		data = data[6:]
		nread += 6
		p.KnownMasterList = make([]struct {
			Address
			UUID UUID
		}, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.KnownMasterList[i]
			{
				l := binary.BigEndian.Uint32(data[0:])
				data = data[4:]
				if uint32(len(data)) < l {
					return 0, ErrDecodeOverflow
				}
				(*a).Address.Host = string(data[:l])
				data = data[l:]
				nread += 4 + l
			}
			(*a).Address.Port = binary.BigEndian.Uint16(data[0:])
			(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[2:])))
			data = data[6:]
			nread += 6
		}
	}
	return int(nread) + 0, nil
}

func (p *PrimaryMaster) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerPrimary) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PrimaryUUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
	return int(nread) + 4, nil
}

func (p *AnnouncePrimary) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *ReelectPrimary) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *Recovery) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerRecovery) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PTid = PTid(binary.BigEndian.Uint64(data[0:]))
	p.BackupTID = Tid(binary.BigEndian.Uint64(data[8:]))
	p.TruncateTID = Tid(binary.BigEndian.Uint64(data[16:]))
	return int(nread) + 24, nil
}

func (p *LastIDs) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerLastIDs) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.LastOID = Oid(binary.BigEndian.Uint64(data[0:]))
	p.LastTID = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *PartitionTable) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerPartitionTable) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PTid = PTid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.RowList = make([]RowInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.RowList[i]
			(*a).Offset = binary.BigEndian.Uint32(data[0:])
			{
				l := binary.BigEndian.Uint32(data[4:])
				data = data[8:]
				nread += 8
				(*a).CellList = make([]CellInfo, l)
				for i := 0; uint32(i) < l; i++ {
					a := &(*a).CellList[i]
					(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
					(*a).CellState = CellState(int32(binary.BigEndian.Uint32(data[4:])))
					data = data[8:]
					nread += 8
				}
			}
			data = data[0:]
			nread += 0
		}
	}
	return int(nread) + 0, nil
}

func (p *NotifyPartitionTable) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PTid = PTid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.RowList = make([]RowInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.RowList[i]
			(*a).Offset = binary.BigEndian.Uint32(data[0:])
			{
				l := binary.BigEndian.Uint32(data[4:])
				data = data[8:]
				nread += 8
				(*a).CellList = make([]CellInfo, l)
				for i := 0; uint32(i) < l; i++ {
					a := &(*a).CellList[i]
					(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
					(*a).CellState = CellState(int32(binary.BigEndian.Uint32(data[4:])))
					data = data[8:]
					nread += 8
				}
			}
			data = data[0:]
			nread += 0
		}
	}
	return int(nread) + 0, nil
}

func (p *PartitionChanges) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PTid = PTid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.CellList = make([]struct {
			Offset    uint32
			UUID      UUID
			CellState CellState
		}, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.CellList[i]
			(*a).Offset = binary.BigEndian.Uint32(data[0:])
			(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[4:])))
			(*a).CellState = CellState(int32(binary.BigEndian.Uint32(data[8:])))
			data = data[12:]
			nread += 12
		}
	}
	return int(nread) + 0, nil
}

func (p *StartOperation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Backup = byte2bool((data[0:])[0])
	return int(nread) + 1, nil
}

func (p *StopOperation) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *UnfinishedTransactions) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerUnfinishedTransactions) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.TidList = make([]struct{ UnfinishedTID Tid }, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.TidList[i]
			(*a).UnfinishedTID = Tid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *LockedTransactions) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerLockedTransactions) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.TidDict = make(map[Tid]Tid, l)
		m := p.TidDict
		for i := 0; uint32(i) < l; i++ {
			key := Tid(binary.BigEndian.Uint64(data[0:]))
			m[key] = Tid(binary.BigEndian.Uint64(data[8:]))
			data = data[16:]
			nread += 16
		}
	}
	return int(nread) + 0, nil
}

func (p *FinalTID) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.TTID = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *AnswerFinalTID) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *ValidateTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.TTID = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Tid = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *BeginTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *AnswerBeginTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *FinishTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.OIDList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OIDList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.CheckedList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.CheckedList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *AnswerFinishTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.TTID = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Tid = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *NotifyTransactionFinished) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.TTID = Tid(binary.BigEndian.Uint64(data[0:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *LockInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Ttid = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Tid = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *AnswerLockInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Ttid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *InvalidateObjects) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.OidList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OidList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *UnlockInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.TTID = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *GenerateOIDs) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.NumOIDs = binary.BigEndian.Uint32(data[0:])
	return int(nread) + 4, nil
}

func (p *AnswerGenerateOIDs) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.OidList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OidList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *StoreObject) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	p.Serial = Tid(binary.BigEndian.Uint64(data[8:]))
	p.Compression = byte2bool((data[16:])[0])
	p.Checksum[0] = (data[17:])[0]
	p.Checksum[1] = (data[18:])[0]
	p.Checksum[2] = (data[19:])[0]
	p.Checksum[3] = (data[20:])[0]
	p.Checksum[4] = (data[21:])[0]
	p.Checksum[5] = (data[22:])[0]
	p.Checksum[6] = (data[23:])[0]
	p.Checksum[7] = (data[24:])[0]
	p.Checksum[8] = (data[25:])[0]
	p.Checksum[9] = (data[26:])[0]
	p.Checksum[10] = (data[27:])[0]
	p.Checksum[11] = (data[28:])[0]
	p.Checksum[12] = (data[29:])[0]
	p.Checksum[13] = (data[30:])[0]
	p.Checksum[14] = (data[31:])[0]
	p.Checksum[15] = (data[32:])[0]
	p.Checksum[16] = (data[33:])[0]
	p.Checksum[17] = (data[34:])[0]
	p.Checksum[18] = (data[35:])[0]
	p.Checksum[19] = (data[36:])[0]
	{
		l := binary.BigEndian.Uint32(data[37:])
		data = data[41:]
		nread += 41
		p.Data = make([]byte, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.Data[i]
			(*a) = (data[0:])[0]
			data = data[1:]
			nread += 1
		}
	}
	p.DataSerial = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Tid = Tid(binary.BigEndian.Uint64(data[8:]))
	p.Unlock = byte2bool((data[16:])[0])
	return int(nread) + 17, nil
}

func (p *AnswerStoreObject) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Conflicting = byte2bool((data[0:])[0])
	p.Oid = Oid(binary.BigEndian.Uint64(data[1:]))
	p.Serial = Tid(binary.BigEndian.Uint64(data[9:]))
	return int(nread) + 17, nil
}

func (p *AbortTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *StoreTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.User = string(data[:l])
		data = data[l:]
		nread += 12 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Description = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Extension = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.OidList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OidList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *VoteTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *GetObject) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	p.Serial = Tid(binary.BigEndian.Uint64(data[8:]))
	p.Tid = Tid(binary.BigEndian.Uint64(data[16:]))
	return int(nread) + 24, nil
}

func (p *AnswerGetObject) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	p.SerialStart = Tid(binary.BigEndian.Uint64(data[8:]))
	p.SerialEnd = Tid(binary.BigEndian.Uint64(data[16:]))
	p.Compression = byte2bool((data[24:])[0])
	p.Checksum[0] = (data[25:])[0]
	p.Checksum[1] = (data[26:])[0]
	p.Checksum[2] = (data[27:])[0]
	p.Checksum[3] = (data[28:])[0]
	p.Checksum[4] = (data[29:])[0]
	p.Checksum[5] = (data[30:])[0]
	p.Checksum[6] = (data[31:])[0]
	p.Checksum[7] = (data[32:])[0]
	p.Checksum[8] = (data[33:])[0]
	p.Checksum[9] = (data[34:])[0]
	p.Checksum[10] = (data[35:])[0]
	p.Checksum[11] = (data[36:])[0]
	p.Checksum[12] = (data[37:])[0]
	p.Checksum[13] = (data[38:])[0]
	p.Checksum[14] = (data[39:])[0]
	p.Checksum[15] = (data[40:])[0]
	p.Checksum[16] = (data[41:])[0]
	p.Checksum[17] = (data[42:])[0]
	p.Checksum[18] = (data[43:])[0]
	p.Checksum[19] = (data[44:])[0]
	{
		l := binary.BigEndian.Uint32(data[45:])
		data = data[49:]
		nread += 49
		p.Data = make([]byte, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.Data[i]
			(*a) = (data[0:])[0]
			data = data[1:]
			nread += 1
		}
	}
	p.DataSerial = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *TIDList) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.First = binary.BigEndian.Uint64(data[0:])
	p.Last = binary.BigEndian.Uint64(data[8:])
	p.Partition = binary.BigEndian.Uint32(data[16:])
	return int(nread) + 20, nil
}

func (p *AnswerTIDList) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.TIDList = make([]Tid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.TIDList[i]
			(*a) = Tid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *TIDListFrom) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.MinTID = Tid(binary.BigEndian.Uint64(data[0:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[8:]))
	p.Length = binary.BigEndian.Uint32(data[16:])
	p.Partition = binary.BigEndian.Uint32(data[20:])
	return int(nread) + 24, nil
}

func (p *AnswerTIDListFrom) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.TidList = make([]Tid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.TidList[i]
			(*a) = Tid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *TransactionInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *AnswerTransactionInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.User = string(data[:l])
		data = data[l:]
		nread += 12 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Description = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Extension = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	p.Packed = byte2bool((data[0:])[0])
	{
		l := binary.BigEndian.Uint32(data[1:])
		data = data[5:]
		nread += 5
		p.OidList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OidList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *ObjectHistory) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	p.First = binary.BigEndian.Uint64(data[8:])
	p.Last = binary.BigEndian.Uint64(data[16:])
	return int(nread) + 24, nil
}

func (p *AnswerObjectHistory) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.HistoryList = make([]struct {
			Serial Tid
			Size   uint32
		}, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.HistoryList[i]
			(*a).Serial = Tid(binary.BigEndian.Uint64(data[0:]))
			(*a).Size = binary.BigEndian.Uint32(data[8:])
			data = data[12:]
			nread += 12
		}
	}
	return int(nread) + 0, nil
}

func (p *PartitionList) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.MinOffset = binary.BigEndian.Uint32(data[0:])
	p.MaxOffset = binary.BigEndian.Uint32(data[4:])
	p.UUID = UUID(int32(binary.BigEndian.Uint32(data[8:])))
	return int(nread) + 12, nil
}

func (p *AnswerPartitionList) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.PTid = PTid(binary.BigEndian.Uint64(data[0:]))
	{
		l := binary.BigEndian.Uint32(data[8:])
		data = data[12:]
		nread += 12
		p.RowList = make([]RowInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.RowList[i]
			(*a).Offset = binary.BigEndian.Uint32(data[0:])
			{
				l := binary.BigEndian.Uint32(data[4:])
				data = data[8:]
				nread += 8
				(*a).CellList = make([]CellInfo, l)
				for i := 0; uint32(i) < l; i++ {
					a := &(*a).CellList[i]
					(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
					(*a).CellState = CellState(int32(binary.BigEndian.Uint32(data[4:])))
					data = data[8:]
					nread += 8
				}
			}
			data = data[0:]
			nread += 0
		}
	}
	return int(nread) + 0, nil
}

func (p *X_NodeList) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.NodeType = NodeType(int32(binary.BigEndian.Uint32(data[0:])))
	return int(nread) + 4, nil
}

func (p *AnswerNodeList) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.NodeList = make([]NodeInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.NodeList[i]
			(*a).NodeType = NodeType(int32(binary.BigEndian.Uint32(data[0:])))
			{
				l := binary.BigEndian.Uint32(data[4:])
				data = data[8:]
				if uint32(len(data)) < l {
					return 0, ErrDecodeOverflow
				}
				(*a).Address.Host = string(data[:l])
				data = data[l:]
				nread += 8 + l
			}
			(*a).Address.Port = binary.BigEndian.Uint16(data[0:])
			(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[2:])))
			(*a).NodeState = NodeState(int32(binary.BigEndian.Uint32(data[6:])))
			(*a).IdTimestamp = float64_NEODecode(data[10:])
			data = data[18:]
			nread += 18
		}
	}
	return int(nread) + 0, nil
}

func (p *SetNodeState) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.UUID = UUID(int32(binary.BigEndian.Uint32(data[0:])))
	p.NodeState = NodeState(int32(binary.BigEndian.Uint32(data[4:])))
	return int(nread) + 8, nil
}

func (p *AddPendingNodes) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.UUIDList = make([]UUID, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.UUIDList[i]
			(*a) = UUID(int32(binary.BigEndian.Uint32(data[0:])))
			data = data[4:]
			nread += 4
		}
	}
	return int(nread) + 0, nil
}

func (p *TweakPartitionTable) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.UUIDList = make([]UUID, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.UUIDList[i]
			(*a) = UUID(int32(binary.BigEndian.Uint32(data[0:])))
			data = data[4:]
			nread += 4
		}
	}
	return int(nread) + 0, nil
}

func (p *NotifyNodeInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.NodeList = make([]NodeInfo, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.NodeList[i]
			(*a).NodeType = NodeType(int32(binary.BigEndian.Uint32(data[0:])))
			{
				l := binary.BigEndian.Uint32(data[4:])
				data = data[8:]
				if uint32(len(data)) < l {
					return 0, ErrDecodeOverflow
				}
				(*a).Address.Host = string(data[:l])
				data = data[l:]
				nread += 8 + l
			}
			(*a).Address.Port = binary.BigEndian.Uint16(data[0:])
			(*a).UUID = UUID(int32(binary.BigEndian.Uint32(data[2:])))
			(*a).NodeState = NodeState(int32(binary.BigEndian.Uint32(data[6:])))
			(*a).IdTimestamp = float64_NEODecode(data[10:])
			data = data[18:]
			nread += 18
		}
	}
	return int(nread) + 0, nil
}

func (p *NodeInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *SetClusterState) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.State = ClusterState(int32(binary.BigEndian.Uint32(data[0:])))
	return int(nread) + 4, nil
}

func (p *ClusterInformation) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.State = ClusterState(int32(binary.BigEndian.Uint32(data[0:])))
	return int(nread) + 4, nil
}

func (p *X_ClusterState) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.State = ClusterState(int32(binary.BigEndian.Uint32(data[0:])))
	return int(nread) + 4, nil
}

func (p *ObjectUndoSerial) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	p.LTID = Tid(binary.BigEndian.Uint64(data[8:]))
	p.UndoneTID = Tid(binary.BigEndian.Uint64(data[16:]))
	{
		l := binary.BigEndian.Uint32(data[24:])
		data = data[28:]
		nread += 28
		p.OidList = make([]Oid, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.OidList[i]
			(*a) = Oid(binary.BigEndian.Uint64(data[0:]))
			data = data[8:]
			nread += 8
		}
	}
	return int(nread) + 0, nil
}

func (p *AnswerObjectUndoSerial) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.ObjectTIDDict = make(map[Oid]struct {
			CurrentSerial Tid
			UndoSerial    Tid
			IsCurrent     bool
		}, l)
		m := p.ObjectTIDDict
		for i := 0; uint32(i) < l; i++ {
			key := Oid(binary.BigEndian.Uint64(data[0:]))
			var v struct {
				CurrentSerial Tid
				UndoSerial    Tid
				IsCurrent     bool
			}
			v.CurrentSerial = Tid(binary.BigEndian.Uint64(data[8:]))
			v.UndoSerial = Tid(binary.BigEndian.Uint64(data[16:]))
			v.IsCurrent = byte2bool((data[24:])[0])
			m[key] = v
			data = data[25:]
			nread += 25
		}
	}
	return int(nread) + 0, nil
}

func (p *HasLock) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Oid = Oid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *AnswerHasLock) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Oid = Oid(binary.BigEndian.Uint64(data[0:]))
	p.LockState = LockState(int32(binary.BigEndian.Uint32(data[8:])))
	return int(nread) + 12, nil
}

func (p *CheckCurrentSerial) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	p.Serial = Tid(binary.BigEndian.Uint64(data[8:]))
	p.Oid = Oid(binary.BigEndian.Uint64(data[16:]))
	return int(nread) + 24, nil
}

func (p *AnswerCheckCurrentSerial) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Conflicting = byte2bool((data[0:])[0])
	p.Oid = Oid(binary.BigEndian.Uint64(data[1:]))
	p.Serial = Tid(binary.BigEndian.Uint64(data[9:]))
	return int(nread) + 17, nil
}

func (p *Pack) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *AnswerPack) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Status = byte2bool((data[0:])[0])
	return int(nread) + 1, nil
}

func (p *CheckReplicas) NEODecode(data []byte) (int, error) {
	var nread uint32
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		nread += 4
		p.PartitionDict = make(map[uint32]UUID, l)
		m := p.PartitionDict
		for i := 0; uint32(i) < l; i++ {
			key := binary.BigEndian.Uint32(data[0:])
			m[key] = UUID(int32(binary.BigEndian.Uint32(data[4:])))
			data = data[8:]
			nread += 8
		}
	}
	p.MinTID = Tid(binary.BigEndian.Uint64(data[0:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[8:]))
	return int(nread) + 16, nil
}

func (p *CheckPartition) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Partition = binary.BigEndian.Uint32(data[0:])
	{
		l := binary.BigEndian.Uint32(data[4:])
		data = data[8:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Source.UpstreamName = string(data[:l])
		data = data[l:]
		nread += 8 + l
	}
	{
		l := binary.BigEndian.Uint32(data[0:])
		data = data[4:]
		if uint32(len(data)) < l {
			return 0, ErrDecodeOverflow
		}
		p.Source.Address.Host = string(data[:l])
		data = data[l:]
		nread += 4 + l
	}
	p.Source.Address.Port = binary.BigEndian.Uint16(data[0:])
	p.MinTID = Tid(binary.BigEndian.Uint64(data[2:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[10:]))
	return int(nread) + 18, nil
}

func (p *CheckTIDRange) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Partition = binary.BigEndian.Uint32(data[0:])
	p.Length = binary.BigEndian.Uint32(data[4:])
	p.MinTID = Tid(binary.BigEndian.Uint64(data[8:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[16:]))
	return int(nread) + 24, nil
}

func (p *AnswerCheckTIDRange) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Count = binary.BigEndian.Uint32(data[0:])
	p.Checksum[0] = (data[4:])[0]
	p.Checksum[1] = (data[5:])[0]
	p.Checksum[2] = (data[6:])[0]
	p.Checksum[3] = (data[7:])[0]
	p.Checksum[4] = (data[8:])[0]
	p.Checksum[5] = (data[9:])[0]
	p.Checksum[6] = (data[10:])[0]
	p.Checksum[7] = (data[11:])[0]
	p.Checksum[8] = (data[12:])[0]
	p.Checksum[9] = (data[13:])[0]
	p.Checksum[10] = (data[14:])[0]
	p.Checksum[11] = (data[15:])[0]
	p.Checksum[12] = (data[16:])[0]
	p.Checksum[13] = (data[17:])[0]
	p.Checksum[14] = (data[18:])[0]
	p.Checksum[15] = (data[19:])[0]
	p.Checksum[16] = (data[20:])[0]
	p.Checksum[17] = (data[21:])[0]
	p.Checksum[18] = (data[22:])[0]
	p.Checksum[19] = (data[23:])[0]
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[24:]))
	return int(nread) + 32, nil
}

func (p *CheckSerialRange) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Partition = binary.BigEndian.Uint32(data[0:])
	p.Length = binary.BigEndian.Uint32(data[4:])
	p.MinTID = Tid(binary.BigEndian.Uint64(data[8:]))
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[16:]))
	p.MinOID = Oid(binary.BigEndian.Uint64(data[24:]))
	return int(nread) + 32, nil
}

func (p *AnswerCheckSerialRange) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Count = binary.BigEndian.Uint32(data[0:])
	p.TidChecksum[0] = (data[4:])[0]
	p.TidChecksum[1] = (data[5:])[0]
	p.TidChecksum[2] = (data[6:])[0]
	p.TidChecksum[3] = (data[7:])[0]
	p.TidChecksum[4] = (data[8:])[0]
	p.TidChecksum[5] = (data[9:])[0]
	p.TidChecksum[6] = (data[10:])[0]
	p.TidChecksum[7] = (data[11:])[0]
	p.TidChecksum[8] = (data[12:])[0]
	p.TidChecksum[9] = (data[13:])[0]
	p.TidChecksum[10] = (data[14:])[0]
	p.TidChecksum[11] = (data[15:])[0]
	p.TidChecksum[12] = (data[16:])[0]
	p.TidChecksum[13] = (data[17:])[0]
	p.TidChecksum[14] = (data[18:])[0]
	p.TidChecksum[15] = (data[19:])[0]
	p.TidChecksum[16] = (data[20:])[0]
	p.TidChecksum[17] = (data[21:])[0]
	p.TidChecksum[18] = (data[22:])[0]
	p.TidChecksum[19] = (data[23:])[0]
	p.MaxTID = Tid(binary.BigEndian.Uint64(data[24:]))
	p.OidChecksum[0] = (data[32:])[0]
	p.OidChecksum[1] = (data[33:])[0]
	p.OidChecksum[2] = (data[34:])[0]
	p.OidChecksum[3] = (data[35:])[0]
	p.OidChecksum[4] = (data[36:])[0]
	p.OidChecksum[5] = (data[37:])[0]
	p.OidChecksum[6] = (data[38:])[0]
	p.OidChecksum[7] = (data[39:])[0]
	p.OidChecksum[8] = (data[40:])[0]
	p.OidChecksum[9] = (data[41:])[0]
	p.OidChecksum[10] = (data[42:])[0]
	p.OidChecksum[11] = (data[43:])[0]
	p.OidChecksum[12] = (data[44:])[0]
	p.OidChecksum[13] = (data[45:])[0]
	p.OidChecksum[14] = (data[46:])[0]
	p.OidChecksum[15] = (data[47:])[0]
	p.OidChecksum[16] = (data[48:])[0]
	p.OidChecksum[17] = (data[49:])[0]
	p.OidChecksum[18] = (data[50:])[0]
	p.OidChecksum[19] = (data[51:])[0]
	p.MaxOID = Oid(binary.BigEndian.Uint64(data[52:]))
	return int(nread) + 60, nil
}

func (p *PartitionCorrupted) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Partition = binary.BigEndian.Uint32(data[0:])
	{
		l := binary.BigEndian.Uint32(data[4:])
		data = data[8:]
		nread += 8
		p.CellList = make([]UUID, l)
		for i := 0; uint32(i) < l; i++ {
			a := &p.CellList[i]
			(*a) = UUID(int32(binary.BigEndian.Uint32(data[0:])))
			data = data[4:]
			nread += 4
		}
	}
	return int(nread) + 0, nil
}

func (p *LastTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}

func (p *AnswerLastTransaction) NEODecode(data []byte) (int, error) {
	var nread uint32
	p.Tid = Tid(binary.BigEndian.Uint64(data[0:]))
	return int(nread) + 8, nil
}

func (p *NotifyReady) NEODecode(data []byte) (int, error) {
	var nread uint32
	return int(nread) + 0, nil
}
